#ifdef gccruntime
#include <stdio.h>
#endif

namespace bnf {

int CaseSensitive;
char* lpSeperatorBytes;
int nSeperatorCount = 0;
char* lpComments;

char ConfigFile[32] = "bnf.cfg";

char* SymbolNames;
int SymbolNameSize;
char** SymbolPointer;

bool Parse = false;
bool List = false;

int DebugOutput;

#include "main.h"

extern int InitGrammar();
extern int ExitGrammar();
extern int Split(char* FileName);
extern int ListSource(char* FileName);

void ReadConfigPrepareString(char* lpStr)
{
	int i, j;

	j = strlen(lpStr);
	lpStr[j] = lpStr[j + 1] = 0;
	
	for (i = 0;i < j;i++)
	{
		if (lpStr[i] == asc(","))
		{
			lpStr[i] = 0;
		}
	}
}

int ReadConfig()
{
	char* PathName;
	char* pTemp;
	int nTemp;

	GetPath(&PathName, ConfigFile);
	CaseSensitive = GetPrivateProfileInt("Config", "CaseSensitive", 1, PathName);

	if (GetPrivateProfileStringA("Config", "SeperatorBytes", &lpSeperatorBytes))
	{
		return(1);
	}

	ReadConfigPrepareString(lpSeperatorBytes);

	pTemp = lpSeperatorBytes;
	while(*pTemp)
	{
		sscanf(pTemp, "%d", &nTemp);
		pTemp += strlen(pTemp) + 1;
		lpSeperatorBytes[nSeperatorCount] = (char) nTemp;
		nSeperatorCount++;
	}

	if (GetPrivateProfileStringA("Config", "Comment", &lpComments))
	{
		return(1);
	}

	ReadConfigPrepareString(lpComments);

	free(PathName);
	return(0);
}

#include "interface.h"

}
