struct CharTemplate
{
	char ident[4];
	int TemplateType;
	int AttributeType;
	int MinLevel;
	int MaxLevel;
	int* Class;
	int ClassCount;
	int* AttributePreset;
	int Monster;
	int MonsterName;
	int Mixed;
	int Race;
	int DrawType;
	struct seedstru
	{
		unsigned long seed[256];
	} seed;
	struct restru
	{
		unsigned long retemp[8192];
		unsigned long repos;
	} re;
};

struct clsMonster
{
	char Name[256];
	int CR;
	int Type;
	int Size;
	int Epic;
	int HD;
	int HDType;
	int TPBonus;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int Attr[6];
	int AC;
	int HDMin;
	int HDMax;
	int HDInc;
	int HDInc2;
	int Init;
	int Speed;
	int OrgMin;
	int OrgMax;
	int Mixed;
	int Treasure;
	int AttackBonus[6];
	int AttackNumber[6];
	int AttackRed[6];
	int DamageA[6];
	int DamageB[6];
	int DamageC[6];
	char AttackType[6][32];
	int AlternateAttack[6];
	int AttackCount;
	int Feats[6];
	int FeatCount;
	int Skills[7];
	int SkillLevels[7];
	int SkillCount;
	char* SpellChar;
	int ClericSpells;
};

struct clsPower
{
	char Name[256];
	int Psion;
	int PsychicW;
	int Attribute;
};

struct clsEffect
{
	char Name[256];
	int Weapon;
	int Armor;
	int Shield;
	int Helmet;
	int Gloves;
	int Boots;
	int Belt;
	int Cloak;
	int Ring;
	int Amulet;
	int Fight;
	int Magic;
	int Shadow;
	int Multi;
	int Cost;
	int Cost2;
	int Quality;
	char* Script;
	char SkillBoost[1024];
};

struct clsSpell
{
	char Name[256];
	int Probability;
	int ClassLevels[128];
	int DomainCount;
	int DomainLevel;
	int Domains[2];
	int School;
};

struct clsEquip
{
	char Name[256];
	int EquipType;
	int Enhencement;
	int Effect[6];
	char EffectDesc[6][256];
	int EffectCount;
	int EffectCountA;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int AttackType;
	int Probability[128];
	int RaceProbability[128];
	int StdProb;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int AttackBonus;
	int AttackBonusA;
	int TwoWeapon;
	int TwoWeaponSecond;
	int TwoHand;
	int MaxStr;
	char DescText[1024];
	int Primary;
	int Secondary;
	int Value;
	int Adamantine;
	int Mithril;
	int Mercury;
	int ShieldUsed;
	int IncludeInTreasure;
	int ID;
	int SpecialType;
	int MaxEnh;
};

struct clsRace
{
	char Name[256];
	int Probability;
	int Size;
	int PreferedAttackType;
	char* Script;
	char RaceMod[128];
};

struct clsChar
{
	int MonsterTWType;
	int MonsterSize;
	int HG;
	int Attributes[6];
	int Mods[6];
	int ClassCount;
	int Classes[32];
	int DummyClass[32];
	int DummyClassClericSpells[32];
	int Level;
	int Levels[32];
	int LevelsClassic[32];
	int Life;
	int LifeBonus;
	int GA;
	int GASize;
	int GAMelee;
	int GAShot;
	int GAMeleeAttr;
	int GAShotAttr;
	int GAMeleeRest;
	int GAShotRest;
	int GAEpic;
	int RWEpic;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int RWRefBase;
	int RWWilBase;
	int RWZaehBase;
	int RWRefAttr;
	int RWWilAttr;
	int RWZaehAttr;
	int RWRefMage;
	int RWWilMage;
	int RWZaehMage;
	int RWRefRest;
	int RWWilRest;
	int RWZaehRest;
	int FeatCount;
	int Feats[512];
	int FeatDependancy[512];
	int FeatDone[512];
	CharTemplate* CreationTemplate;
	int AttackType[2];
	int AttackTypeCount;
	clsEquip Equipment[32];
	int EquipCount;
	int Skills[512];
	int SkillLevels[512];
	int SkillLevels2[512];
	int SkillCount;
	int SkillCountReal;
	int SkillPoints;
	int Race;
	int SkillRequired[512];
	int SpellsKnownCount[32][10];
	int SpellList[32][10][10];
	int SpellsPerDayCount[32][10];
	int SpellListCount[32][10];
	int Domains[2];
	int DomainSpells[10];
	int DomainSpellCount;
	int Specialised;
	int School;
	int SchoolForbidden[9];
	char CharText[65536];
	char CharTextPrimary[65536];
	char CharTextSecondary[65536];
	char CharTextTwo[65536];
	int WeaponArmorShieldFeats;
	int AC;
	int ACArmor;
	int ACShield;
	int ACDex;
	int ACSize;
	int ACRest;
	float Range;
	int MR;
	int MRBonus;
	int againstMR;
	int PR;
	int againstPR;
	int Attacks;
	int Attacks2;
	int AttacksOpportunity;
	int MonkAttacks;
	int SpecialAbbilities;
	int Lores;
	int Initiative;
	int InitiativeRest;
	int InitiativeDex;
	int ArmorMalus;
	int MaxDex;
	int RingMax;
	int BonusSpells;
	int BonusSpellLevelMin;
	int BonusSpellLevelMax;
	int AttackMod;
	int DmgMod;
	int Money;
	int MoneyRest;
	int Treasure;
	int TreasureLeft;
	int UnarmedDamage1;
	int UnarmedDamage2;
	int PowerPoints;
	int MainDisciple;
	int CrystalCount;
	int CombatModes;
	int dart;
	int Monster;
	int MonsterName;
	int MonsterType;
	int MAttackBonus[6];
	int MAttackNumber[6];
	int MAttackRed[6];
	int MDamageA[6];
	int MDamageB[6];
	int MDamageC[6];
	char MAttackType[6][32];
	int MAlternateAttack[6];
	int MAttackCount;
	int MSize;
	int HighestSpell;
	int CRPosCount;
	int CRPosHD[32];
	int CRPosTemplate[32];
	int CRPosCR[32];
	int SpellFailure;
	int Profiled;
	int ProfileStrength;
	int Profile;
	int Mixed;
	int MixedHG;
	int SneakDmg;
	int Evasion;
	int DestroyUndead;
	int Smite;
	int Dex2AC;
	int UncannyDodge;
	int LowLightVision;
	int DarkVision;
	int Rel;
	int InbornLeft;
	int CreationTime;
	int HasTemplate;
};

struct clsCharSource
{
	int Count;
	char Name[256];
	int TW;
	int AttributePriority[6];
	int Probability;
	int GA;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int PreferedAttack;
	int ForceAttack;
	int Skills;
	int Prestige;
	int MaxLevel;
	int MaxLevelA;
	char* Script;
	char* ClassFeats;
	int SpellType;
	int IncreaseSpellType;
	int SpontanCast;
	int SpontanCast2;
	int Domains;
	int Specialize;
	int PowerType;
	char ReqStr[1024];
	char SkillStr[1024];
	char FeatStr[1024];
	char BonusFeatType[256];
	char BonusFeats[256];
	int EpicFeats;
	int SpellFailure;
	int UseEffects;
	char AttachClass[256];
	int NoEq;
	int PsionicDisciple;
	int PsiCrystal;
	int ForceWeaponType;
	int NaturalEnhence;
};

struct clsFeatSource
{
	char Name[256];
	int Probability[128];
	int MultipleTimes;
	int Epic;
	char ReqStr[1024];
	char SkillStr[1024];
	int DepType;
	char* Script;
	int AttackDep;
	int FeatType;
	char Text[16394];
	int Inborn;
	int Rel[64];
	int RelCount;
	int Standard;
};

struct clsSkills
{
	char Name[256];
	int Prob[128];
	int Attr;
};

struct clsDomainSource
{
	char Name[256];
};
struct clsMonsterTypeSource
{
	char Name[256];
	int GAType;
	int RWRefType;
	int RWWilType;
	int RWZaehType;
	int Mixed;
	int MixedEq;
};
struct clsRegionSource
{
	char Name[256];
};
struct clsSchoolSource
{
	char Name[256];
};
struct clsSizeSource
{
	char Name[256];
	int Mods[3];
	int AC;
	int SizeMod;
};
struct clsTemplateSource
{
	char Name[256];
	char* CRScript;
	int Mixed;
	char ForceType[1024];
	char ForbitType[1024];
	char* Script;
	int AttributeMod[6];
	char NewType[256];
};

struct clsSource
{
	clsCharSource*	CharSource;
	int CharSourceCount;
	clsFeatSource* FeatSource;
	int FeatSourceCount;
	clsEquip* EquipSource;
	int EquipSourceCount;
	clsSkills* SkillSource;
	int SkillSourceCount;
	clsRace* RaceSource;
	int RaceSourceCount;
	clsSpell* SpellSource;
	int SpellSourceCount;
	clsPower* PowerSource;
	int PowerSourceCount;
	clsEffect* EffectSource;
	int EffectSourceCount;
	clsMonster* MonsterSource;
	int MonsterSourceCount;

	clsSchoolSource* SchoolSource;
	int SchoolSourceCount;
	clsSizeSource* SizeSource;
	int SizeSourceCount;
	clsMonsterTypeSource* MonsterTypeSource;
	int MonsterTypeSourceCount;
	clsDomainSource* DomainSource;
	int DomainSourceCount;
	clsTemplateSource* TemplateSource;
	int TemplateSourceCount;
	clsRegionSource* RegionSource;
	int RegionSourceCount;

	char AttributeNames[6][32];

	int StartMoney[100];
	int Treasure[100];

	int InitCharSource();
};

clsSource Source;
