int CountFeats(clsChar* TargetStruct, int FeatNumber, int featsyet)
{
	int i, temp;
	temp = 0;
	for (i = 0;i < featsyet;i++)
	{
		if (TargetStruct->Feats[i] == FeatNumber)
		{
			temp++;
		}
	}
	return(temp);
}

bool FeatPresent(clsChar* TargetStruct, int FeatNumber, int featsyet, int FeatDep)
{
	int i;
	
	for (i = 0;i < featsyet;i++)
	{
		if (TargetStruct->Feats[i] == FeatNumber &&
			(FeatDep == -2 || TargetStruct->FeatDependancy[i] == FeatDep || TargetStruct->FeatDependancy[i] == -1))
		{
			return(true);
		}
	}
	return(false);
}

bool CheckFinessPossible(clsChar* TargetStruct)
{
	int i;
	for (i = 0;i < TargetStruct->EquipCount;i++)
	{
		if (strcmp(TargetStruct->Equipment[i].Name, "Rapier") == 0 || strcmp(TargetStruct->Equipment[i].Name, "Krummsbel") == 0)
		{
			return(true);
		}
	}
	return(false);
}

bool CheckReq(clsChar* TargetStruct, int FeatNumber, int featsyet, char* ReqStr, int curlevel, int* AgainProb)
{
	char* ReqPos = ReqStr;
	char* TempPos;
	int ReqID, ReqIVal;
	char ReqTVal[1024];
	int i, j, k, len, num;
	bool retval;

	while (*ReqPos)
	{
		ReqID = TwoCharToInt(ReqPos);
		ReqPos += 3;

		if (ReqID == TwoCharToInt("PR"))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber(ReqPos), featsyet))
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("PG"))
		{
			if (CountFeats(TargetStruct, GetFeatNumber(ReqPos), featsyet) <= CountFeats(TargetStruct, FeatNumber, featsyet))
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("HS"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->HighestSpell < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("KR"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (!IsClass(TargetStruct, GetCharNumber("Barbar")) || TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] / 4 + 1 < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("GA"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->GA < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("CL"))
		{

			retval = false;
			num = substr_count(asc("|"), ReqPos) + 1;
			len = strlen(ReqPos);

			TempPos = ReqPos;
			str_replace(asc("|"), 0, ReqPos);
			for (i = 0;i < num;i++)
			{
				sscanf(TempPos, "%s %d", ReqTVal, &ReqIVal);
				if (IsClass(TargetStruct, GetCharNumber(ReqTVal)) && TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber(ReqTVal))] >= ReqIVal)
				{
					retval = true;;
				}
				TempPos += strlen(TempPos) + 1;
			}
			str_replace(0, asc("|"), ReqPos, len);
			if (retval == false)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("ST"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[0] < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("GE"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[1] < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("KO"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[2] < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("IN"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[3] < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("WE"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[4] < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("CH"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[5] < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("RA"))
		{
			retval = false;
			num = substr_count(asc("|"), ReqPos) + 1;
			len = strlen(ReqPos);

			TempPos = ReqPos;
			str_replace(asc("|"), 0, ReqPos);
			for (i = 0;i < num;i++)
			{
				if (TargetStruct->Race == GetRaceNumber(TempPos))
				{
					retval = true;
				}
				TempPos += strlen(TempPos) + 1;
			}
			str_replace(0, asc("|"), ReqPos, len);
			if (retval == false)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("NC"))
		{
			if (IsClass(TargetStruct, GetCharNumber(ReqPos)))
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("LV"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (curlevel < ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("SF"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->RWZaehBase > ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("SW"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->RWWilBase > ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("SR"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->RWRefBase > ReqIVal)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("MM"))
		{
			return(false);
		}
		else if (ReqID == TwoCharToInt("PF"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			j = 0;
			for (i = 0;i < featsyet;i++)
			{
				if (Source.FeatSource[TargetStruct->Feats[i]].FeatType == 3)
				{
					j++;
				}
			}
			if (ReqIVal < j)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("MF"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			j = 0;
			for (i = 0;i < featsyet;i++)
			{
				if (Source.FeatSource[TargetStruct->Feats[i]].FeatType == 1)
				{
					j++;
				}
			}
			if (ReqIVal < j)
			{
				if (AgainProb)
				{
					AgainProb[FeatNumber] = 0;
				}
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("SN"))
		{
			return(IsClass(TargetStruct, GetCharNumber("Schurke")) || IsClass(TargetStruct, GetCharNumber("Assasin")));
		}
		else if (ReqID == TwoCharToInt("DV"))
		{
			return(TargetStruct->Race == GetRaceNumber("Zwerg") || TargetStruct->Race == GetRaceNumber("Halbork"));
		}
		else if (ReqID == TwoCharToInt("SP"))
		{
			ReqIVal = GetSpellNumber(ReqPos);
			for (i = 0;i < TargetStruct->ClassCount;i++)
			{
				for (j = 0;j < 10;j++)
				{
					for (k = 0;k < TargetStruct->SpellListCount[i][j];k++)
					{
						if (TargetStruct->SpellList[i][j][k] == ReqIVal)
						{
							return(true);
						}
					}
				}
			}
			if (AgainProb)
			{
				AgainProb[FeatNumber] = 0;
			}
			return(false);
		}
		else
		{
			printf("Unknown Feat Rule: %s\n", ReqPos - 3);
			quitprog();
		}

		ReqPos += strlen(ReqPos) + 1;
	}

	return(true);
}

bool FeatPossible(clsChar* TargetStruct, int FeatNumber, int featsyet, int* AgainProb = 0)
{
	int i;
	clsChar TestChar;
	ClearChar(&TestChar);
	TestChar.FeatCount = 1;
	TestChar.Feats[0] = FeatNumber;
	SetFeatSkills(&TestChar);

	char* ReqPos;

	ReqPos = Source.FeatSource[FeatNumber].ReqStr;

	if (!CheckReq(TargetStruct, FeatNumber, featsyet, ReqPos, 0, AgainProb))
	{
		return(false);
	}

	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (TestChar.SkillRequired[i] > TargetStruct->Level + 3)
		{
			return(false);
		}
	}

	if (GetFeatNumber("Waffenfinesse") == FeatNumber)
	{
		return((TargetStruct->Attributes[1] > TargetStruct->Attributes[0] ? true : false)
			&& (CheckFinessPossible(TargetStruct)));
	}

	if (GetFeatNumber("ZenArchery") == FeatNumber)
	{
		return((TargetStruct->Attributes[4] > TargetStruct->Attributes[1] ? true : false)
			&& (CheckFinessPossible(TargetStruct)));
	}

	if (GetFeatNumber("FamiliarSpell") == FeatNumber)
	{
		return ((TargetStruct->Attributes[3] >= 25 ? true : false) || (TargetStruct->Attributes[4] >= 25 ? true : false));
	}

	if (GetFeatNumber("ImprovedAlignmentBaseCasting") == FeatNumber)
	{
		return ((TargetStruct->HighestSpell >= 9 ? true : false)
		&& (
			TargetStruct->Domains[0] == GetDomainNumber("Gutes")
			|| TargetStruct->Domains[1] == GetDomainNumber("Gutes")
			|| TargetStruct->Domains[0] == GetDomainNumber("Bses")
			|| TargetStruct->Domains[1] == GetDomainNumber("Bses")
			|| TargetStruct->Domains[0] == GetDomainNumber("Chaos")
			|| TargetStruct->Domains[1] == GetDomainNumber("Chaos")
			|| TargetStruct->Domains[0] == GetDomainNumber("Ordnung")
			|| TargetStruct->Domains[1] == GetDomainNumber("Ordnung")
		));
	}

	if (GetFeatNumber("ImprovedArrowOfDeath") == FeatNumber)
	{
		return ((TargetStruct->Attributes[1] >= 19 ? true : false) || (TargetStruct->Attributes[4] >= 19 ? true : false));
	}

	if (GetFeatNumber("ImprovedSpellCasting") == FeatNumber)
	{
		return (
			(IsClass(TargetStruct, GetCharNumber("Barde")) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barde"))] >= 16 ? true : false))
			|| (TargetStruct->HighestSpell >= 9 ? true : false)
			);
	}

	if (GetFeatNumber("InstantReload") == FeatNumber)
	{
		for (i = 0;i < TargetStruct->EquipCount;i++)
		{
			if (TargetStruct->Equipment[i].SpecialType == 3)
			{
				return(true);
			}
		}
		return(false);
	}
	
	
	if (GetFeatNumber("SpellKnowledge") == FeatNumber)
	{
		return (
			(IsClass(TargetStruct, GetCharNumber("Barde")) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barde"))] >= 16 ? true : false))
			|| (TargetStruct->HighestSpell >= 9 ? true : false)
			);
	}
	
	return(true);
}

void DoFeatDep(clsChar* TargetStruct, int FeatNumber)
{
	int i, j, k, l;
	int TempProb[4096];

	char* ReqPos;
	bool CopyFeatDep = false;
	int CopyDepSrc;

	ZeroMemory(TempProb, 4096 * sizeof(int));
	TargetStruct->FeatDependancy[FeatNumber] = -2;
	if (Source.FeatSource[TargetStruct->Feats[FeatNumber]].DepType && TargetStruct->Feats[FeatNumber] != GetFeatNumber("EinfacheWaffen") && TargetStruct->Feats[FeatNumber] != GetFeatNumber("KriegsWaffen") && TargetStruct->Feats[FeatNumber] != GetFeatNumber("ExotischeWaffen"))
	{
		ReqPos = Source.FeatSource[TargetStruct->Feats[FeatNumber]].ReqStr;
		while (*ReqPos)
		{
			if (TwoCharToInt(ReqPos) == TwoCharToInt("PG"))
			{
				CopyFeatDep = true;
				CopyDepSrc = GetFeatNumber(ReqPos + 3);
				break;
			}
			ReqPos += strlen(ReqPos) + 1;
		}

		if (CopyFeatDep)
		{
			for (i = 0;i < FeatNumber;i++)
			{
				if (TargetStruct->Feats[i] == CopyDepSrc
					&& !FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, TargetStruct->FeatDependancy[i]))
				{
					TargetStruct->FeatDependancy[FeatNumber] = TargetStruct->FeatDependancy[i];
					return;
				}
			}
		}
		else
		{
			if (Source.FeatSource[TargetStruct->Feats[FeatNumber]].DepType == depweapon)
			{
				for (i = 0;i < TargetStruct->EquipCount;i++)
				{
					if (TargetStruct->Equipment[i].EquipType == EquipWeapon && !(FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, GetEquipNumber(TargetStruct->Equipment[i].Name))))
					{
						TargetStruct->FeatDependancy[FeatNumber] = GetEquipNumber(TargetStruct->Equipment[i].Name);
						return;
					}
				}
				for (i = 0;i < Source.EquipSourceCount;i++)
				{
					if (Source.EquipSource[i].EquipType == EquipWeapon && !(FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, GetEquipNumber(Source.EquipSource[i].Name))))
					{
						TempProb[i] = 1;
					}
				}
				TargetStruct->FeatDependancy[FeatNumber] = AdvancedRand(Source.EquipSourceCount, TempProb, sizeof(int), &Source.EquipSource[0].Name[0], sizeof(clsEquip), "Waffe fr Talent whlen!\n");
			}

			if (Source.FeatSource[TargetStruct->Feats[FeatNumber]].DepType == depspell)
			{
				for (i = 0;i < Source.SchoolSourceCount - 1;i++)
				{
					TempProb[i] = 0;
					if (!FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, i))
					{
						for (l = 0;l < TargetStruct->ClassCount;l++)
						{
							for (j = 0;j <= 9;j++)
							{
								for (k = 0;k < TargetStruct->SpellListCount[l][j];k++)
								{
									if (i == Source.SpellSource[TargetStruct->SpellList[l][j][k]].School)
									{
										TempProb[i] ++;
									}
								}
							}
						}
					}
				}
				if (TargetStruct->Profiled)
				{
					SecureMultiply(&TempProb[Profiles[TargetStruct->Profile].PreferedSchool], TargetStruct->ProfileStrength);
				}
				adverror = 0;
				TargetStruct->FeatDependancy[FeatNumber] = AdvancedRand(Source.SchoolSourceCount - 1, TempProb, sizeof(int), &Source.SchoolSource[0].Name[0], sizeof(clsSchoolSource), "Schule fr Zauberfokus whlen!\n");
				if (TargetStruct->FeatDependancy[FeatNumber] == -1)
				{
					TargetStruct->Feats[FeatNumber] = GetFeatNumber("Abhrtung");
					TargetStruct->FeatDependancy[FeatNumber] = -2;
				}
			}
		}
	}
}

void AddFeat(clsChar* TargetStruct, int FeatNumber, int* featsyet, int Dep)
{
	int i;

	if (featsyet == NULL)
	{
		featsyet = &TargetStruct->FeatCount;
	}
	for (i = 0;i < *featsyet;i++)
	{
		if ((TargetStruct->Feats[i] == FeatNumber)
			&& (TargetStruct->FeatDependancy[i] == Dep || TargetStruct->FeatDependancy[i] == -1))
		{
			return;
		}
		if (TargetStruct->Feats[i] == FeatNumber && Dep == -1)
		{
			TargetStruct->FeatDependancy[i] = -1;
		}
	}
	TargetStruct->Feats[*featsyet] = FeatNumber;
	TargetStruct->FeatDependancy[*featsyet] = Dep;
	(*featsyet)++;
	TargetStruct->FeatCount++;
}

void AddFeat(clsChar* TargetStruct, char* FeatName, int* featsyet, int Dep)
{
	AddFeat(TargetStruct, GetFeatNumber(FeatName), featsyet, Dep);
}

int CheckFeatReq(clsChar* TargetStruct, int num)
{
	int i;
	char* CheckPos;

	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		CheckPos = Source.CharSource[TargetStruct->Classes[i]].FeatStr;
		while (*CheckPos)
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber(CheckPos), num))
			{
				TargetStruct->Feats[num] = GetFeatNumber(CheckPos);
				DoFeatDep(TargetStruct, num);
				return(1);
			}
			CheckPos += strlen(CheckPos) + 1;
		}
	}
	return(0);
}

unsigned int AgainDep[1024];

void FeatAgain(int* Probability, int nFeat)
{
	unsigned int Border = 1;

	if (Source.FeatSource[nFeat].MultipleTimes == 0)
	{
		Probability[nFeat] = 0;
	}
	else if (Source.FeatSource[nFeat].MultipleTimes == 1)
	{
		if (Source.FeatSource[nFeat].DepType == depweapon)
		{
			Border = max(1, AgainDep[nFeat]);
			AgainDep[nFeat] /= 2;
		}
		sprintf(tempout, "Enter 1 to make Feat %s possible again\n", Source.FeatSource[nFeat].Name);
		if (random(1, 8, tempout) > Border)
		{
			Probability[nFeat] = 0;
		}
		else
		{
			Probability[nFeat] = GreaterZero(Probability[nFeat] / 2);
		}
	}
}

void DoFeats(clsChar* TargetStruct, int* ProbabilityMod, int Class, bool ClassFeat, int* featsyet, int Epic = 0)
{
	int i, j, k, l;
	int Probability[1024];
	int ProbSave[1024];
	int temp, temp2; 
	bool featok;
	int FeatTypeMatch;
	char* FeatCheckPos;
	int FeatCheckTemp;

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		if (ClassFeat)
		{
			Probability[i] = Source.FeatSource[i].Probability[Class] * TargetStruct->Level;
		}
		else
		{
			Probability[i] = 0;
			for (j = 0;j < TargetStruct->ClassCount;j++)
			{
				Probability[i] += Source.FeatSource[i].Probability[TargetStruct->Classes[j]] * TargetStruct->Levels[j];
			}
		}
		Probability[i] += ProbabilityMod[i] * TargetStruct->Level;
		if ((Source.FeatSource[i].Epic > Epic))
		{
			Probability[i] = 0;
		}
		if ((Source.FeatSource[i].Epic < Epic))
		{
			Probability[i] /= 10;
		}

		if (Source.FeatSource[i].RelCount)
		{
			k = 0;
			for (j = 0;j < Source.FeatSource[j].RelCount;j++)
			{
				if (Source.FeatSource[i].Rel[j] == TargetStruct->Rel)
				{
					k = 1;
					break;
				}
			}
			Probability[i] *= k;
		}

		if (Source.FeatSource[i].Standard)
		{
			Probability[i] *= 5;
		}

		if (Source.FeatSource[i].AttackDep)
		{
			if (TargetStruct->AttackType[0] != AttackTwoWeapons && TargetStruct->AttackType[1] != AttackTwoWeapons)
			{
				if (Source.FeatSource[i].AttackDep == 2)
				{
					Probability[i] = 0;
				}
			}
			if ((TargetStruct->AttackType[0] == AttackBow || TargetStruct->AttackType[0] == AttackNone) && TargetStruct->AttackType[1] == AttackNone)
			{
				if (Source.FeatSource[i].AttackDep == 1)
				{
					Probability[i] = 0;
				}
			}
			if (TargetStruct->AttackType[0] != AttackBow && TargetStruct->AttackType[1] != AttackBow)
			{
				if (Source.FeatSource[i].AttackDep == 4)
				{
					Probability[i] = 0;
				}
			}
		}

		if (FeatPresent(TargetStruct, i, *featsyet))
		{
			FeatAgain(Probability, i);
		}
	}

	for (i = *featsyet;i < TargetStruct->FeatCount;i++)
	{
		if (CheckFeatReq(TargetStruct, i))
		{
			FeatAgain(Probability, TargetStruct->Feats[i]);
			goto FeatNextA;
		}

		if (TargetStruct->InbornLeft == 0)
		{
			for (j = 0;j < Source.FeatSourceCount;j++)
			{
				if (TargetStruct->InbornLeft == 0 && Source.FeatSource[j].Inborn)
				{
					Probability[j] = 0;
				}
			}
			TargetStruct->InbornLeft--;
		}

		if (ClassFeat && *Source.CharSource[Class].BonusFeatType)
		{
			for (j = 0;j < Source.FeatSourceCount;j++)
			{
				FeatTypeMatch = 0;
				FeatCheckPos = Source.CharSource[Class].BonusFeatType;
				while (*FeatCheckPos)
				{
					sscanf(FeatCheckPos, "%d", &FeatCheckTemp);
					if (Source.FeatSource[j].FeatType == FeatCheckTemp)
					{
						FeatTypeMatch = 1;
						break;
					}
					FeatCheckPos += strlen(FeatCheckPos) + 1;
				}
				if (FeatTypeMatch == 0)
				{
					Probability[j] = 0;
				}
			}
		}
		else
		{
			if (TargetStruct->WeaponArmorShieldFeats == 1)
			{
				for (k = 0;k < TargetStruct->EquipCount;k++)
				{
					if (TargetStruct->Equipment[k].EquipType == EquipWeapon || TargetStruct->Equipment[k].EquipType == EquipArmor || TargetStruct->Equipment[k].EquipType == EquipShield)
					{
						temp2 = GetFeatNumber(GetTypeName(TargetStruct->Equipment[k].EquipType, TargetStruct->Equipment[k].Type));

						if (temp2 == GetFeatNumber("SchwereRstung") && !FeatPresent(TargetStruct, GetFeatNumber("MittelschwereRstung"), *featsyet))
						{
							temp2 = GetFeatNumber("MittelschwereRstung");
						}
	
						if (temp2 == GetFeatNumber("MittelschwereRstung") && !FeatPresent(TargetStruct, GetFeatNumber("LeichteRstung"), *featsyet))
						{
							temp2 = GetFeatNumber("LeichteRstung");
						}
				
						featok = false;
						for (l = 0;l < TargetStruct->FeatCount;l++)
						{
							if (TargetStruct->Feats[l] == temp2 && (TargetStruct->FeatDependancy[l] == GetEquipNumber(TargetStruct->Equipment[k].Name) || TargetStruct->FeatDependancy[l] == -1))
							{
								featok = true;
							}
						}
			
						if (!featok)
						{
							TargetStruct->Feats[i] = temp2;
							TargetStruct->FeatDependancy[i] = GetEquipNumber(TargetStruct->Equipment[k].Name);
							if (temp2 == GetFeatNumber("EinfacheWaffen")) {TargetStruct->FeatDependancy[i] = -1;}
							goto FeatNext;
						}
					}
				}
			}
		}
		temp = 1;

		if (TargetStruct->Profiled)
		{
			for (l = 0;l < Profiles[TargetStruct->Profile].FeatCount;l++)
			{
				if ((!FeatPresent(TargetStruct, Profiles[TargetStruct->Profile].Feats[l].Feat, i)) &&
					FeatPossible(TargetStruct, Profiles[TargetStruct->Profile].Feats[l].Feat, i) &&
					Probability[Profiles[TargetStruct->Profile].Feats[l].Feat] != 0)
				{
					SecureMultiply(&Probability[Profiles[TargetStruct->Profile].Feats[l].Feat], TargetStruct->ProfileStrength);
					break;
				}
			}
		}

		CopyMemory(ProbSave, Probability, Source.FeatSourceCount * sizeof(int));

		do
		{
			if (temp < 1000)
			{
				if (temp > 1)
				{
					Probability[TargetStruct->Feats[i]] = 0;
					if (DebugOutput)
					{
						printf("Feat not allowed yet, trying some other... :|\n");
					}
				}
				sprintf(tempout, "Talent %d / %d\n", i, TargetStruct->FeatCount);
				if (ClassFeat)
				{
					sprintf(tempstring, "Bonustalent: %s\n", Source.CharSource[Class].Name);
					strcat(tempout, tempstring);
				}
					
				strcat(tempout, "Talent whlen!\n");
				adverror = 0;
				TargetStruct->Feats[i] = AdvancedRand(Source.FeatSourceCount, &Probability[0], sizeof(int),
					&Source.FeatSource[0].Name[0], sizeof(clsFeatSource), tempout);
				if (TargetStruct->Feats[i] == -1)
				{
					goto NoAppropriate;
				}
			}
			else
			{
NoAppropriate:
				if (DebugOutput) {printf("No apropriate Feat found %d\n", i);}
				tempout[0] = 0;
				for (l = 0;l < Source.FeatSourceCount;l++)
				{
					sprintf(tempstring, "%d: %s\n", l, Source.FeatSource[l].Name);
					strcat(tempout, tempstring);
				}
				strcat(tempout, "Select a Feat!\n");
				TargetStruct->Feats[i] = random(0, Source.FeatSourceCount - 1, tempout);
			}
			temp++;
		}
		while (!FeatPossible(TargetStruct, TargetStruct->Feats[i], i, ProbSave));

		if (Source.FeatSource[TargetStruct->Feats[i]].Inborn)
		{
			TargetStruct->InbornLeft--;
		}

		CopyMemory(Probability, ProbSave, Source.FeatSourceCount * sizeof(int));
		
		FeatAgain(Probability, TargetStruct->Feats[i]);

FeatNextA:;
		DoFeatDep(TargetStruct, i);
FeatNext:;
	}
	*featsyet = TargetStruct->FeatCount;
}

void DoClassRaceFeats(clsChar* TargetStruct, int* featsyetA)
{
	int featsyet;

	featsyet = *featsyetA;
	sAddfeatsyet = &featsyet;

	int i;

	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		classlevel = TargetStruct->Levels[i];
		if (DebugOutput) {printf("\nRunning ClassFeat - Script for %s\n", Source.CharSource[TargetStruct->Classes[i]].Name);}
		RunScript(TargetStruct, NULL, TargetStruct->CharText, Source.CharSource[TargetStruct->Classes[i]].ClassFeats);
	}
	classlevel = 0;

	sAddfeatsyet = 0;
	*featsyetA = featsyet;
}

int CalcBonusFeat(char* BonusStr, int CharLevel)
{
	char* BonusPos = BonusStr;
	int CurFeats = 0;
	int Increment, Division;
	while (*BonusPos)
	{
		if (strstr(BonusPos, " "))
		{
			sscanf(BonusPos, "%d %d", &Increment, &Division);
			CurFeats += (CharLevel + Increment) / Division;
		}
		else
		{
			sscanf(BonusPos, "%d", &Increment);
			if (CharLevel > Increment)
			{
				CurFeats++;
			}
		}
		BonusPos += strlen(BonusPos) + 1;
	}
	return(CurFeats);
}

void CalculateFeats(clsChar* TargetStruct)
{
	int i, featsyet = 0;
	int *ProbMod;
	ProbMod = new int[Source.FeatSourceCount];
	int AddFeats;

	char WeaponTemp[1024];
	if (ProbMod == 0)
	{
		printf("Memmory Allocation Error...\n");
		quitprog();
	}

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		AgainDep[i] = (TargetStruct->AttackType[0] == AttackTwoWeapons && TargetStruct->EquipCount && TargetStruct->Equipment[0].AttackType != AttackBiWeapon ? 6 : 3);
		if (TargetStruct->AttackType[1] != AttackNone)
		{
			AgainDep[i]++;
		}
		ProbMod[i] = 0;
	}

	DoClassRaceFeats(TargetStruct, &featsyet);

	if (TargetStruct->Domains[0] == GetDomainNumber("Krieg") || TargetStruct->Domains[1] == GetDomainNumber("Krieg"))
	{
		if (TargetStruct->AttackType != AttackNone && TargetStruct->EquipCount)
		{
			i = GetEquipNumber(TargetStruct->Equipment[0].Name);
			AddFeat(TargetStruct, "Waffenfokus",  &featsyet, i);
			if (TargetStruct->Equipment[0].Type == 0) {strcpy(WeaponTemp, "EinfacheWaffen");i = -1;}
			if (TargetStruct->Equipment[0].Type == 1) {strcpy(WeaponTemp, "KriegsWaffen");}
			if (TargetStruct->Equipment[0].Type == 2) {strcpy(WeaponTemp, "ExotischeWaffen");}
			AddFeat(TargetStruct, WeaponTemp, &featsyet, i);
		}
	}

	TargetStruct->InbornLeft = 1;
	if (IsClass(TargetStruct, GetCharNumber("Kmpfer"))) {TargetStruct->InbornLeft++;}
	if (TargetStruct->Race == GetRaceNumber("Mensch")) {TargetStruct->InbornLeft++;}

	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		AddFeats = CalcBonusFeat(Source.CharSource[TargetStruct->Classes[i]].BonusFeats, TargetStruct->LevelsClassic[i]);
		if (AddFeats)
		{
			TargetStruct->FeatCount += AddFeats;
			DoFeats(TargetStruct, ProbMod, TargetStruct->Classes[i], 1, &featsyet);
		}
	}

	TargetStruct->FeatCount += min(TargetStruct->Level, 20) / 3 + 1;
	if (TargetStruct->Race == GetRaceNumber("Mensch") && DummyChar == 0) {TargetStruct->FeatCount++;}

	while (TargetStruct->SpecialAbbilities > 0 && random(1, 3, "1 = Use Special Ability as Feat") == 1)
	{
		TargetStruct->SpecialAbbilities--;
		TargetStruct->FeatCount++;;
	}

	DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet);

	TargetStruct->FeatCount += max(0, TargetStruct->Level - 18) / 3;
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		TargetStruct->FeatCount += (TargetStruct->Levels[i] - TargetStruct->LevelsClassic[i]) / Source.CharSource[TargetStruct->Classes[i]].EpicFeats;
	}
	DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet, 1);

	delete[] ProbMod;
}

void SetMin(int* val, int minval)
{
	*val = max(*val, minval);
}

void SetReqSkills(clsChar* TargetStruct, char* SkillReqStr)
{
	char SkillName[256];
	int SkillLvl;
	char* SkillPos = SkillReqStr;
	while (*SkillPos)
	{
		sscanf(SkillPos, "%s %d", SkillName, &SkillLvl);
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber(SkillName)], SkillLvl);
		SkillPos += strlen(SkillPos) + 1;
	}
}

void SetFeatSkills(clsChar* TargetStruct)
{
	int i;
	char* SkillPos;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		SkillPos = Source.FeatSource[TargetStruct->Feats[i]].SkillStr;
		SetReqSkills(TargetStruct, SkillPos);
	}
}

void SetFeatSkillsA(clsChar* TargetStruct)
{
	int i;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		if (Source.FeatSource[TargetStruct->Feats[i]].DepType == depskill)
		{
			sprintf(tempout, "Fertigkeit fr Fertigkeitsbezogenes Talent %s whlen! whlen!\n", Source.FeatSource[TargetStruct->Feats[i]].Name);
			if (TargetStruct->SkillCount == 0)
			{
				TargetStruct->FeatDependancy[i] = random(0, Source.SkillSourceCount - 1, tempout);
			}
			else
			{
				TargetStruct->FeatDependancy[i] = TargetStruct->Skills[random(0, TargetStruct->SkillCount - 1, tempout)];
			}
		}
	}
}

void DoFeatEffects(clsChar* TargetStruct)
{
	int i, j, k;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		if (TargetStruct->Feats[i] == GetFeatNumber("PsionicBody"))
		{
			mCheckChars(PsionicDisciple)
			if (mCheckCharsResult)
			{
				if (TargetStruct->Mods[TargetStruct->MainDisciple] > TargetStruct->Mods[2])
				{
					TargetStruct->LifeBonus += TargetStruct->Mods[TargetStruct->MainDisciple];
					TargetStruct->LifeBonus -= TargetStruct->Mods[2];
				}
			}
			for (j = 0;j < TargetStruct->FeatCount;j++)
			{
				if (TargetStruct->Feats[j] == GetFeatNumber("DelayPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("EnlargePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("ExtendPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("HeightenPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("HidePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("MasterDorje")
					|| TargetStruct->Feats[j] == GetFeatNumber("MaximizePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("QuickenPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("TwinPower"))
				{
					TargetStruct->LifeBonus++;
				}
			}
		}
		else
		{
			TargetStruct->FeatDone[i] = 1;
		}

		if (Source.FeatSource[TargetStruct->Feats[i]].Script[5] != asc(";"))
		{
			TargetStruct->FeatDone[i] = 0;
			if (DebugOutput) {printf("\nRunning Script for %s\n", Source.FeatSource[TargetStruct->Feats[i]].Name);}
			RunScript(TargetStruct, NULL, TargetStruct->CharText, Source.FeatSource[TargetStruct->Feats[i]].Script, i);
		}

		if (Source.FeatSource[TargetStruct->Feats[i]].Text[1] != 0)
		{
			TargetStruct->FeatDone[i] = 0;
			strcat(TargetStruct->CharText, Source.FeatSource[TargetStruct->Feats[i]].Text);strcat(TargetStruct->CharText, "\n");
		}
	}
	
	j = -1;
	k = 0;
	for (i = 0;i < TargetStruct->EquipCount;i++)
	{
		if (!(
			FeatPresent(TargetStruct, GetFeatNumber("EinfacheWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			|| FeatPresent(TargetStruct, GetFeatNumber("KriegsWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			|| FeatPresent(TargetStruct, GetFeatNumber("ExotischeWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			))
		{
			TargetStruct->Equipment[i].AttackBonus -= 2;
			if (!FeatPresent(TargetStruct, GetFeatNumber("ImprovisedWeaponProficiency"), TargetStruct->FeatCount))
			{
				TargetStruct->Equipment[i].AttackBonus -= 2;
			}
		}
		if (TargetStruct->Equipment[i].EquipType == EquipArmor && strcmp(TargetStruct->Equipment[i].Name, "Magierrobe") != 0)
		{
			j = max(j, TargetStruct->Equipment[i].Type);
		}
		if (TargetStruct->Equipment[i].EquipType == EquipShield)
		{
			k = 1;
		}
	}
	if (j >= 0)
	{
		if (!(FeatPresent(TargetStruct, GetFeatNumber(GetTypeName(EquipArmor, j)), TargetStruct->FeatCount)))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				TargetStruct->Equipment[j].AttackBonus -= 4;
			}
			TargetStruct->ArmorMalus += 4;
		}
	}
	if (k == 1 && (!(FeatPresent(TargetStruct, GetFeatNumber("Schilde"), TargetStruct->FeatCount))))
	{
		for (j = 0;j < TargetStruct->EquipCount;j++)
		{
			TargetStruct->Equipment[j].AttackBonus -= 4;
		}
		TargetStruct->ArmorMalus += 4;
	}
}

void StripFeats(clsChar* TargetStruct)
{
	int i;
	int j;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		for (j = 0;j < TargetStruct->FeatCount;j++)
		{
			if (i != j)
			{
				if (TargetStruct->Feats[i] == TargetStruct->Feats[j])
				{
					if (TargetStruct->FeatDependancy[i] == TargetStruct->FeatDependancy[j] ||
						TargetStruct->FeatDependancy[i] == -1)
					{
						TargetStruct->Feats[j] = TargetStruct->Feats[TargetStruct->FeatCount - 1];
						TargetStruct->FeatDependancy[j] = TargetStruct->FeatDependancy[TargetStruct->FeatCount - 1];
						TargetStruct->FeatDone[j] = TargetStruct->FeatDone[TargetStruct->FeatCount - 1];
						TargetStruct->FeatCount--;
					}
				}
			}
			if (i >= TargetStruct->FeatCount)
			{
				break;
			}
		}
	}
}
