void SetEffectSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, weapon, armor, shield, helmet, ring, amulet, gloves, boots, belt, cloak, fight, magic, shadow, multi, cost, cost2, valcount;
	static int scriptpos, skillboostpos;
	
	if (header)
	{
		name = GetValNumber(Vals, "Effect", Number);
		weapon = GetValNumber(Vals, "Weapon", Number);
		armor = GetValNumber(Vals, "Armor", Number);
		shield = GetValNumber(Vals, "Shield", Number);
		helmet = GetValNumber(Vals, "Helmet", Number);
		ring = GetValNumber(Vals, "Ring", Number);
		amulet = GetValNumber(Vals, "Amulet", Number);
		gloves = GetValNumber(Vals, "Gloves", Number);
		boots = GetValNumber(Vals, "Boots", Number);
		belt = GetValNumber(Vals, "Belt", Number);
		cloak = GetValNumber(Vals, "Cloak", Number);
		fight = GetValNumber(Vals, "Fight", Number);
		magic = GetValNumber(Vals, "Mage", Number);
		shadow = GetValNumber(Vals, "Shadow", Number);
		multi = GetValNumber(Vals, "Multi", Number);
		cost = GetValNumber(Vals, "Cost", Number);
		cost2 = GetValNumber(Vals, "Cost2", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		skillboostpos = GetValNumber(Vals, "SkillBoost", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in EffectSource Database\n");
		quitprog();
	}
	
	strcpy(((clsEffect*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[weapon], "%d", &(((clsEffect*) TargetStruct)->Weapon));
	sscanf(Vals[armor], "%d", &(((clsEffect*) TargetStruct)->Armor));
	sscanf(Vals[shield], "%d", &(((clsEffect*) TargetStruct)->Shield));
	sscanf(Vals[helmet], "%d", &(((clsEffect*) TargetStruct)->Helmet));
	sscanf(Vals[ring], "%d", &(((clsEffect*) TargetStruct)->Ring));
	sscanf(Vals[amulet], "%d", &(((clsEffect*) TargetStruct)->Amulet));
	sscanf(Vals[gloves], "%d", &(((clsEffect*) TargetStruct)->Gloves));
	sscanf(Vals[boots], "%d", &(((clsEffect*) TargetStruct)->Boots));
	sscanf(Vals[belt], "%d", &(((clsEffect*) TargetStruct)->Belt));
	sscanf(Vals[cloak], "%d", &(((clsEffect*) TargetStruct)->Cloak));
	sscanf(Vals[fight], "%d", &(((clsEffect*) TargetStruct)->Fight));
	sscanf(Vals[magic], "%d", &(((clsEffect*) TargetStruct)->Magic));
	sscanf(Vals[shadow], "%d", &(((clsEffect*) TargetStruct)->Shadow));
	sscanf(Vals[multi], "%d", &(((clsEffect*) TargetStruct)->Multi));
	sscanf(Vals[cost], "%d", &(((clsEffect*) TargetStruct)->Cost));
	sscanf(Vals[cost2], "%d", &(((clsEffect*) TargetStruct)->Cost2));

	strcpy(((clsEffect*) TargetStruct)->SkillBoost, Vals[skillboostpos]);
	str_replace(asc(","), asc(" "), ((clsEffect*) TargetStruct)->SkillBoost);
	str_replace(asc(";"), 0, ((clsEffect*) TargetStruct)->SkillBoost);
	
	if (bnf::bnfparse(Vals[scriptpos], &(((clsEffect*) TargetStruct)->Script)))
	{
		printf("Error in Effect Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetEffectNumber(char* EffectName)
{
	int i;
	for (i = 0;i < Source.EffectSourceCount;i++)
	{
		if (strcmp(EffectName, Source.EffectSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Effect not found(%s)\n", EffectName);
	quitprog();
	return(0);
}

void EffectSourceExit()
{
	int i;
	for (i = 0;i < Source.EffectSourceCount;i++)
	{
		free(Source.EffectSource[i].Script);
	}
	delete[] Source.EffectSource;
}
