void SetFeatSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;
	static int ClassPosition[128];
	static int MultiPos, name, epic, valcount, reqpos, skillpos, deppos, scriptpos, attackdeppos, feattypepos;
	static int TextPos, InbornPos, RelPos, StandardPos;

	char* TempPos;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name, Number);
		}
		MultiPos = GetValNumber(Vals, "Multi", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		name = GetValNumber(Vals, "Name", Number);
		reqpos = GetValNumber(Vals, "Req", Number);
		skillpos = GetValNumber(Vals, "SkillReq", Number);
		deppos = GetValNumber(Vals, "Dep", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		attackdeppos = GetValNumber(Vals, "AttackDep", Number);
		feattypepos = GetValNumber(Vals, "FeatType", Number);
		TextPos = GetValNumber(Vals, "Text", Number);
		InbornPos = GetValNumber(Vals, "Inborn", Number);
		RelPos = GetValNumber(Vals, "Rel", Number);
		StandardPos = GetValNumber(Vals, "Standard", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in FeatSource Database\n");
		quitprog();
	}
	
	strcpy(((clsFeatSource*) TargetStruct)->Name, Vals[name]);
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		sscanf(Vals[ClassPosition[i]], "%d", &(((clsFeatSource*) TargetStruct)->Probability[i]));
	}
	sscanf(Vals[MultiPos], "%d", &(((clsFeatSource*) TargetStruct)->MultipleTimes));
	sscanf(Vals[epic], "%d", &(((clsFeatSource*) TargetStruct)->Epic));
	sscanf(Vals[deppos], "%d", &(((clsFeatSource*) TargetStruct)->DepType));
	sscanf(Vals[feattypepos], "%d", &(((clsFeatSource*) TargetStruct)->FeatType));

	sscanf(Vals[InbornPos], "%d", &(((clsFeatSource*) TargetStruct)->Inborn));
	sscanf(Vals[StandardPos], "%d", &(((clsFeatSource*) TargetStruct)->Standard));

	((clsFeatSource*) TargetStruct)->RelCount = 0;
	if (strlen(Vals[RelPos]) > 1)
	{
		str_replace(asc(";"), 0, Vals[RelPos]);
		TempPos = Vals[RelPos];
		while (*TempPos)
		{
			((clsFeatSource*) TargetStruct)->Rel[((clsFeatSource*) TargetStruct)->RelCount] = GetRegionNumber(TempPos);
			((clsFeatSource*) TargetStruct)->RelCount++;
			TempPos += strlen(TempPos) + 1;
		}
	}

	strcpy(((clsFeatSource*) TargetStruct)->Text, Vals[TextPos]);
	str_replace(asc("_"), asc(" "), ((clsFeatSource*) TargetStruct)->Text);

	strcpy(((clsFeatSource*) TargetStruct)->ReqStr, Vals[reqpos]);
	strcpy(((clsFeatSource*) TargetStruct)->SkillStr, Vals[skillpos]);

	str_replace(asc(","), asc(" "), ((clsFeatSource*) TargetStruct)->ReqStr);
	str_replace(asc(";"), 0, ((clsFeatSource*) TargetStruct)->ReqStr);

	str_replace(asc(","), asc(" "), ((clsFeatSource*) TargetStruct)->SkillStr);
	str_replace(asc(";"), 0, ((clsFeatSource*) TargetStruct)->SkillStr);

	sscanf(Vals[attackdeppos], "%d", &(((clsFeatSource*) TargetStruct)->AttackDep));

	if (bnf::bnfparse(Vals[scriptpos], &(((clsFeatSource*) TargetStruct)->Script)))
	{
		printf("Error in Feat Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetFeatNumber(char* FeatName, int uncomplete = 0)
{
	int i;
	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		if (strcmp(FeatName, Source.FeatSource[i].Name) == 0)
		{
			return(i);
		}
		if (uncomplete == 1 && strstr(Source.FeatSource[i].Name, FeatName) != 0)
		{
			return(i);
		}
	}
	printf("Feat not found(%s)\n", FeatName);
	quitprog();
	return(0);
}

void FeatSourceExit()
{
	int i;
	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		free(Source.FeatSource[i].Script);
	}
	delete[] Source.FeatSource;
}
