void SetMonsterTypeSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int valcount, gapos, refpos, wilpos, zaehpos, namepos, mixedpos, mixedeqpos;

	if (header)
	{
		namepos = GetValNumber(Vals, "Name", Number);
		gapos = GetValNumber(Vals, "GA", Number);
		refpos = GetValNumber(Vals, "RWRef", Number);
		wilpos = GetValNumber(Vals, "RWWil", Number);
		zaehpos = GetValNumber(Vals, "RWZaeh", Number);
		mixedpos = GetValNumber(Vals, "Mixed", Number);
		mixedeqpos = GetValNumber(Vals, "MixedEq", Number);

		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in MonsterTypeSource Database\n");
		quitprog();
	}

	strcpy(((clsMonsterTypeSource*) TargetStruct)->Name, Vals[namepos]);

	sscanf(Vals[gapos], "%d", &(((clsMonsterTypeSource*) TargetStruct)->GAType));
	sscanf(Vals[refpos], "%d", &(((clsMonsterTypeSource*) TargetStruct)->RWRefType));
	sscanf(Vals[wilpos], "%d", &(((clsMonsterTypeSource*) TargetStruct)->RWWilType));
	sscanf(Vals[zaehpos], "%d", &(((clsMonsterTypeSource*) TargetStruct)->RWZaehType));
	sscanf(Vals[mixedpos], "%d", &(((clsMonsterTypeSource*) TargetStruct)->Mixed));
	sscanf(Vals[mixedeqpos], "%d", &(((clsMonsterTypeSource*) TargetStruct)->MixedEq));
}

int GetMonsterTypeNumber(char* MonsterTypeName)
{
	int i;
	for (i = 0;i < Source.MonsterTypeSourceCount;i++)
	{
		if (strstr(Source.MonsterTypeSource[i].Name, MonsterTypeName) != 0)
		{
			return(i);
		}
	}
	printf("MonsterType not found(%s)\n", MonsterTypeName);
	quitprog();
	return(0);
}

void MonsterTypeSourceExit()
{
	delete[] Source.MonsterTypeSource;
}
