void SetRaceSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, prob, size, attack, scriptpos, modpos, valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		size = GetValNumber(Vals, "Size", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		modpos = GetValNumber(Vals, "RaceMod", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		valcount = Number;
		return;
	}
		
	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Race Source Database\n");
		quitprog();
	}

	strcpy(((clsRace*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[prob], "%d", &(((clsRace*) TargetStruct)->Probability));	
	sscanf(Vals[size], "%d", &(((clsRace*) TargetStruct)->Size));	
	sscanf(Vals[attack], "%d", &(((clsRace*) TargetStruct)->PreferedAttackType));

	strcpy(((clsRace*) TargetStruct)->RaceMod, Vals[modpos]);
	str_replace(asc(";"), 0, ((clsRace*) TargetStruct)->RaceMod);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsRace*) TargetStruct)->Script)))
	{
		printf("Error in Race Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetRaceNumber(char* RaceName)
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		if (strcmp(RaceName, Source.RaceSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Race not found(%s)\n", RaceName);
	quitprog();
	return(0);
}

void RaceSourceExit()
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		free(Source.RaceSource[i].Script);
	}
	delete[] Source.RaceSource;
}
