void SetTemplateSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int valcount, namepos, crscriptpos, mixedpos, forcetypepos, forbittypepos, scriptpos, attrpos;
	static int newtypepos;
	char* pAttrPos;
	int i;

	if (header)
	{
		namepos = GetValNumber(Vals, "Name", Number);
		crscriptpos = GetValNumber(Vals, "CRScript", Number);
		mixedpos = GetValNumber(Vals, "Mixed", Number);
		forcetypepos = GetValNumber(Vals, "ForceType", Number);
		forbittypepos = GetValNumber(Vals, "ForbitType", Number);
		scriptpos = GetValNumber(Vals, "Script", Number);
		attrpos = GetValNumber(Vals, "AttrMod", Number);
		newtypepos = GetValNumber(Vals, "NewType", Number);

		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in TemplateSource Database\n");
		quitprog();
	}

	strcpy(((clsTemplateSource*) TargetStruct)->Name, Vals[namepos]);
	sscanf(Vals[mixedpos], "%d", &(((clsTemplateSource*) TargetStruct)->Mixed));

	strcpy(((clsTemplateSource*) TargetStruct)->NewType, Vals[newtypepos]);

	strcpy(((clsTemplateSource*) TargetStruct)->ForceType, Vals[forcetypepos]);
	strcpy(((clsTemplateSource*) TargetStruct)->ForbitType, Vals[forbittypepos]);
	str_replace(asc(";"), 0, ((clsTemplateSource*) TargetStruct)->ForceType);
	str_replace(asc(";"), 0, ((clsTemplateSource*) TargetStruct)->ForbitType);

	str_replace(asc(";"), 0, Vals[attrpos]);
	pAttrPos = Vals[attrpos];
	for (i = 0;i < 6;i++)
	{
		sscanf(pAttrPos, "%d", &((clsTemplateSource*) TargetStruct)->AttributeMod[i]);
		pAttrPos += strlen(pAttrPos) + 1;
	}
	
	if (bnf::bnfparse(Vals[crscriptpos], &(((clsTemplateSource*) TargetStruct)->CRScript)) ||
		bnf::bnfparse(Vals[scriptpos], &(((clsTemplateSource*) TargetStruct)->Script)))
	{
		printf("Error in Template Script %s\n", Vals[namepos]);
		quitprog();
	}
}

int GetTemplateNumber(char* TemplateName)
{
	int i;
	for (i = 0;i < Source.TemplateSourceCount;i++)
	{
		if (strcmp(TemplateName, Source.TemplateSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Template not found(%s)\n", TemplateName);
	quitprog();
	return(0);
}

void TemplateSourceExit()
{
	int i;
	for (i = 0;i < Source.TemplateSourceCount;i++)
	{
		free(Source.TemplateSource[i].CRScript);
		free(Source.TemplateSource[i].Script);
	}
	delete[] Source.TemplateSource;
}
